#!/bin/ash
[ -z "$mac" ] && exit
[ -z "$ip" -a -z "$ua" ] && exit

baseDir="/var/stats"
now="`date -u +%s`"
if [ -z "$ssid" ] ; then
  find $baseDir -type d -name "$mac" | awk -v ip="$ip" ua="$ua" now="$now" '{
    system("echo -n \""ua"\" > "$0"/ua")
    system("echo -n \""ip"\" > "$0"/ip")
    system("echo -n \""now"\" > "$0"/updatedAt")
  }'
else
  sessionDir="$baseDir/ssid${ssid}/sessions/${mac}"
  mkdir -p "$sessionDir" && \
    echo -n "$ip" > "$sessionDir/ip" && \
    echo -n "$ua" > "$sessionDir/ua" && \
    echo -n "$now" > "$sessionDir/updatedAt"
fi
