dofile "/www/web/wifi/cgiutils.lua"
dofile "/www/web/wifi/common-handler.lua"

_G["DEBUG"] = 1

local iOSUa = "Mozilla/5.0 (iPhone; CPU iPhone OS 13_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0.5 Mobile/15E148 Safari/604.1"
local androidUa = "Mozilla/5.0 (Linux; Android 8.0.0; SM-G960F Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.137 Mobile Safari/537.36"

local function unCollect(env)
  local mac = getMac(env)
  local ssid = getSsid(env)
  local cmd = "ipset add authenticated" .. ssid .. " " .. mac
  pcall(cmdCall, cmd)
end

local function collect(env)
  local mac = getMac(env)
  local ssid = getSsid(env)
  local ip = env.REMOTE_ADDR
  local data = { ssid = ssid, ip = ip, mac = mac, ua = env.HTTP_USER_AGENT }
  local cmd = table2Qs(data, " ", "=", true) .. " /www/script/collector/ip-ua-dump.sh"
  pcall(cmdCall, cmd)
end

local function next(env)
  if isIOSCnaRequest(env) then
    log("response ios cna")
    print("Content-Type: text/html")
    print("Connection: Close")
    print("")
    print(
      "<HTML><HEAD><TITLE>Success</TITLE></HEAD><BODY>Success</BODY></HTML>"
    )

    env.HTTP_USER_AGENT = iOSUa;
    collect(env)
    return
  end
  if isAndroidCnaRequest(env) then
    log("response android cna")
    httpStatus("204 No Content")
    print("Connection: Close")
    print("")

    env.HTTP_USER_AGENT = androidUa;
    collect(env)
    return
  end

  unCollect(env)
  collect(env)
  redirect302(env.REQUEST_URI)
end

function handle_request(env)
  if not env.HTTP_USER_AGENT then
    env.HTTP_USER_AGENT = env.headers["User-Agent"] or env.headers["user-agent"]
  end

  next(env)
end
